unit UTestMatrixImage;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  MatrixImage, StdCtrls, ImgList, ExtCtrls;

type
  TForm1 = class(TForm)
    ImageList1: TImageList;
    Image1: TImage;
    Button2: TButton;
    MatrixImage1: TMatrixImage;
    procedure FormCreate(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    procedure CaricaBitmaps(SourceDir: string; Recursive: Boolean);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ImageList1.Height := 32;
  ImageList1.Width := 32;
  CaricaBitmaps('.\Bitmaps\', False);

end;

procedure TForm1.Button2Click(Sender: TObject);
var
  j, i: Integer;
  r, c: Integer;
begin
  Button2.Enabled := False;
// serpentone
  for j := -12 to ImageList1.Count + 12 do
  begin
// 12 celle
    for i := 0 to 13 do
    begin
// riga e colonna
      if i < 6 then
      begin
        r := 3;
        c := i;
      end
      else
        if i = 6 then
        begin
          r := 2;
          c := 5;
        end
        else
          if i = 7 then
          begin
            r := 1;
            c := 5;
          end
          else
          begin
            r := 0;
            c := 0 - (i - 13);
          end;
// indice
      if (j + i < 0) or (j + i > ImageList1.Count - 1) then
// immagine off
        MatrixImage1.RemovePicture(r, c)
      else
// immagine of
        MatrixImage1.AssignPictureIndex(r, c, j + i);
    end;
    sleep(300);
    Application.ProcessMessages;
  end;
  Button2.Enabled := True;
end;

procedure TForm1.CaricaBitmaps(SourceDir: string; Recursive: Boolean);
var
  r: TSearchRec;
  b: TBitmap;
begin
  if FindFirst(SourceDir+'*.bmp', faDirectory+faArchive, r)=0 then
    repeat
      if (r.Name<>'.') and (r.Name<>'..') then
        if (r.Attr and faDirectory<>0) and Recursive then
          CaricaBitmaps(SourceDir+r.Name+'\', Recursive)
        else
        begin
          b := TBitmap.Create;
          b.LoadFromFile(SourceDir+r.Name);
          ImageList1.Add(b, nil);
          b.Free;
        end;
    until FindNext(r)<>0;
end;

end.
